import { type JsChunk, type JsCompilation } from "@rspack/binding";
import { ChunkGroup } from "./ChunkGroup";
export declare class Chunk {
    #private;
    name?: string;
    id?: string;
    ids: Array<string>;
    idNameHints: Array<string>;
    filenameTemplate?: string;
    cssFilenameTemplate?: string;
    files: Array<string>;
    runtime: Array<string>;
    hash?: string;
    contentHash: Record<string, string>;
    renderedHash?: string;
    chunkReasons: Array<string>;
    auxiliaryFiles: Array<string>;
    static __from_binding(chunk: JsChunk, compilation: JsCompilation): Chunk;
    constructor(chunk: JsChunk, compilation: JsCompilation);
    isOnlyInitial(): boolean;
    canBeInitial(): boolean;
    hasRuntime(): boolean;
    get groupsIterable(): Iterable<ChunkGroup>;
    getAllAsyncChunks(): Iterable<Chunk>;
    getAllInitialChunks(): Iterable<Chunk>;
    getAllReferencedChunks(): Iterable<Chunk>;
    __internal_inner_ukey(): number;
}
